-- matriz_leds_pkg.vhd
-- Contém os caracteres que formam a mensagem a ser exibida na matriz de LEDs

library ieee;
	use ieee.std_logic_1164.all;
	use ieee.numeric_std.all;
	
package matriz_leds_pkg is
	
	constant NUM_CHAR   : natural := 17;  -- comprimento da string ("DHW - ALTERA" --> 12). Para teste, foi definida somente as letras DHW 
	constant	NUM_MUX	  : natural := 125;--00;--000;  -- define quantas vezes um caracter é multiplexado (define o tempo de exibição). Será definido após implementaçao na placa.
		
	type char is array (integer range 0 to 4) of std_logic_vector(7 downto 0);
	constant char_M: char := char'(		-- letra M
		"11111111",
		"00000010",
		"00000100",
		"00000010",
		"11111111"
	);
	
	constant char_C: char := char'(		-- letra C
		"01111110",
		"10000001",
		"10000001",
		"10000001",
		"00000000"
	);
	
	constant char_N: char := char'(		-- letra N
		"11111111",
		"00000100",
		"00010000",
		"01000000",
		"11111111"
	);
	
	constant char_I: char := char'(		-- letra I
		"00000000",
		"10000001",
		"11111111",
		"10000001",
		"00000000"
	);
	
	constant char_D: char := char'(		-- letra D
		"11111111",
		"10000001",
		"10000001",
		"01000010",
		"00111100"
	);

	constant char_H: char := char'(		-- letra H   
		"11111111",
		"00010000",
		"00010000",
		"00010000",
		"11111111"
	);
	
	constant char_W: char := char'(		-- letra W
		"01111111",
		"10000000",
		"01110000",
		"10000000",
		"01111111"
	);	
   
   constant char_traco: char := char'(		-- letra -
		"00011000",
		"00011000",
		"00011000",
		"00011000",
		"00011000"
	);	
	constant char_A: char := char'(		-- letra A
		"11111110",
		"00010001",
		"00010001",
		"00010001",
		"11111110"
	);	
   constant char_L: char := char'(		-- letra L
		"11111111",
		"10000000",
		"10000000",
		"10000000",
		"10000000"
	);	
   constant char_T: char := char'(		-- letra T
		"00000001",
		"00000001",
		"11111111",
		"00000001",
		"00000001"
	);
   constant char_E: char := char'(		-- letra E
		"11111111",
		"10001001",
		"10001001",
		"10001001",
		"10000001"
	);
   
   constant char_R: char := char'(		-- letra R
		"11111111",
		"00010001",
		"00110001",
		"01010001",
		"10001110"
	);
   
	type ROM is array (0 to NUM_CHAR-1) of char;
	constant msg:  ROM := ROM'(
      char_M,
		char_A,
		char_C,
		char_N,
		char_I,
		char_C,
		char_A,
		char_D,
		char_H,
		char_W,
      char_traco,
      char_A,
      char_L,
      char_T,
      char_E,
      char_R,
      char_A
	);
	
end package matriz_leds_pkg;